import type { DbConnection, GraphQueryResultMetaFromBackend } from 'ts-common';
import type { QueryText } from '../../queryExecution/model';
import { sqlQueryService } from './sqlService';
import { cypherQueryService } from './cypherService';

export const languageQueryService = (db: DbConnection, query: QueryText, useCached: boolean): Promise<GraphQueryResultMetaFromBackend> => {
  if (db.type === 'postgres') {
    return sqlQueryService(db, query, useCached);
  } else if (db.type === 'neo4j' || db.type === 'memgraph') {
    return cypherQueryService(db, query, useCached);
  } else {
    throw new Error('Unsupported database type');
  }
};
